# Note that this is NOT a relocatable package
%define ver     0.5.0
%define rel     0
%define prefix  /usr/local
%define name    xine-lib

Name:        %{name}
Summary:     A Free Video Player.
Summary(ko):   ÷̾
Version:     %{ver}
Release:     %{rel}
Copyright:   GPL
Group:       Development/Libraries
Source:      xine-lib-0.5.0.tar.gz
URL:         http://xine.sourceforge.net
Packager:    Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
BuildRoot:   /tmp/%{name}-root

%package oss
Summary:     XINE - oss support.
Group:       Development/Libraries
Requires:    xine-lib >= 0.5.0

%package alsa05
Summary:     XINE - alsa 0.5.x support.
Group:       Development/Libraries
Requires:    xine-lib >= 0.5.0

#%package alsa09
#Summary:     XINE - alsa >= 0.9.x support.
#Group:       Development/Libraries
#Requires:    xine-lib >= 0.5.0

#%package arts
#Summary:     XINE - arts support.
#Group:       Development/Libraries
#Requires:    xine-lib >= 0.5.0

%package esd
Summary:     XINE - esd support.
Group:       Development/Libraries
Requires:    xine-lib >= 0.5.0, libesd

#%package dxr3
#Summary:     XINE - DXR3 support.
#Group:       Development/Libraries
#Requires:    xine-lib >= 0.5.0

%package xv
Summary:     XINE - XFree XVideo support.
Group:       Development/Libraries
Requires:    xine-lib >= 0.5.0

#%package aa
#Summary:     XINE - Ascii Art support.
#Group:       Development/Libraries
#Requires:    xine-lib >= 0.5.0, libaa

%package w32dll
Summary:     XINE - win32dll decoder support.
Group:       Development/Libraries
Requires:    xine-lib >= 0.5.0

%package d4d
Summary:     XINE - CSS support.
Group:       Applications/X11
Requires:    xine-lib >= %{ver}

%package docs
Summary:     XINE - html API documentation.
Group:       Documentation

%description
xine is a free gpl-licensed video player for unix-like systems.
We support mpeg-2 and mpeg-1 system (audio + video multiplexed) streams,
eventually mpeg-4 and other formats might be added.

xine plays the video and audio data of mpeg-2 videos and synchronizes
the playback of both. Depending on the properties of the mpeg stream,
playback will need more or less processor power, 100% frame rate
has been seen on a 400 MHz P II system.

%description -l fr
xine est un lecteur vido libre sous license GPL pour les systmes de
type unix. Nous supportons les flux mpeg-2 et mpeg-1 (audio + vido 
multiplexs), ventuellement le mpeg-4 et d'autres formats peuvent
tres ajouts.

xine joue les donnes vido et audio de vido mpeg-2 et synchronise
la lecture des deux. En fonction des proprites du flux mpeg,
la lecture aura besoin de plus ou moins de puissance du processeur, 
100% de restitution de trame a t vus sur un systme PII 400MHz.

%description -l ko
xine  GPL̼  UNIX   ÷̾Դϴ. 
÷̾ mpeg-2  mpeg 1 Ʈ ϸ,  
 ߿ mpeg-4  ٸ    Դϴ.

%description oss
audio plugin with oss support.

%description alsa05
audio plugin with alsa 0.5.x support.

#%description alsa09
#audio plugin with alsa >= 0.9.x support.

#%description arts
#audio plugin with arts support.

%description esd
audio plugin with esd support.

#%description dxr3
#video/decoder plugins for DXR3 card support.

%description xv
video plugin using XFree XVideo extension.

#%description aa
#video plugin using Ascii Art library.

%description w32dll
win32dll decoder support.

%description d4d
Using this plugin, you are able to view all of your encrypted and locked dvds without even
noticing that someone tried real hard to keep you from doing so... finally dvd playback
really comes to linux.
Author: Plitsch-Platsch <plitsch@platsch.aq>

%description docs
HTML documentation of XINE API.

%prep
%setup -n xine-lib-0.5.0

%build
./configure --prefix=%{prefix}
make

%install
if [ -d $RPM_BUILD_ROOT ]; then rm -rf $RPM_BUILD_ROOT; fi
#mkdir -p $RPM_BUILD_ROOT/usr/include/X11/pixmaps
make install-strip prefix=$RPM_BUILD_ROOT%{prefix}
#cp doc/*.xpm $RPM_BUILD_ROOT/usr/include/X11/pixmaps

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{prefix}/bin/xine-config
%{prefix}/man/man3/xine-lib.3.gz
%{prefix}/man/man3/ao_functions_t.3.gz
%{prefix}/man/man3/demux_strategy.3.gz
%{prefix}/man/man3/video_cap.3.gz
%{prefix}/man/man3/vo_overlay_t.3.gz
%{prefix}/man/man3/autoplay_group.3.gz
%{prefix}/man/man3/event_group.3.gz
%{prefix}/man/man3/video_group.3.gz
%{prefix}/man/man3/xine.h.3.gz
%{prefix}/man/man3/browse_group.3.gz
%{prefix}/man/man3/loadplugins_group.3.gz
%{prefix}/man/man3/video_prop.3.gz
%{prefix}/man/man3/xine_api.3.gz
%{prefix}/man/man3/build_info.3.gz
%{prefix}/man/man3/mrl_t.3.gz
%{prefix}/man/man3/video_ratio.3.gz
%{prefix}/man/man3/xine_init.3.gz
%{prefix}/man/man3/cfg_data_t.3.gz
%{prefix}/man/man3/mrl_types.3.gz
%{prefix}/man/man3/visual_types.3.gz
%{prefix}/man/man3/xine_management.3.gz
%{prefix}/man/man3/config_group.3.gz
%{prefix}/man/man3/status_group.3.gz
%{prefix}/man/man3/vo_driver_s.3.gz
%{prefix}/man/man3/xine_t.3.gz
%{prefix}/man/man3/config_values_s.3.gz
%{prefix}/man/man3/ui_callbacks.3.gz
%{prefix}/man/man3/vo_driver_t.3.gz
%{prefix}/man/man3/xine_version.3.gz
%{prefix}/man/man3/config_values_t.3.gz
%{prefix}/man/man3/version_group.3.gz
%{prefix}/man/man3/vo_frame_t.3.gz
%{prefix}/include/xine/*.h
%{prefix}/include/xine.h
# input plugins
%{prefix}/lib/xine/plugins/xineplug_inp_dvd.la
%{prefix}/lib/xine/plugins/xineplug_inp_dvd.so
%{prefix}/lib/xine/plugins/xineplug_inp_file.la
%{prefix}/lib/xine/plugins/xineplug_inp_file.so
%{prefix}/lib/xine/plugins/xineplug_inp_net.la
%{prefix}/lib/xine/plugins/xineplug_inp_net.so
%{prefix}/lib/xine/plugins/xineplug_inp_rtp.la
%{prefix}/lib/xine/plugins/xineplug_inp_rtp.so
%{prefix}/lib/xine/plugins/xineplug_inp_stdin_fifo.la
%{prefix}/lib/xine/plugins/xineplug_inp_stdin_fifo.so
%{prefix}/lib/xine/plugins/xineplug_inp_vcd.la
%{prefix}/lib/xine/plugins/xineplug_inp_vcd.so
# demuxer plugins
%{prefix}/lib/xine/plugins/xineplug_dmx_avi.la
%{prefix}/lib/xine/plugins/xineplug_dmx_avi.so
%{prefix}/lib/xine/plugins/xineplug_dmx_mpeg.la
%{prefix}/lib/xine/plugins/xineplug_dmx_mpeg.so
%{prefix}/lib/xine/plugins/xineplug_dmx_mpeg_audio.la
%{prefix}/lib/xine/plugins/xineplug_dmx_mpeg_audio.so
%{prefix}/lib/xine/plugins/xineplug_dmx_mpeg_block.la
%{prefix}/lib/xine/plugins/xineplug_dmx_mpeg_block.so
%{prefix}/lib/xine/plugins/xineplug_dmx_mpeg_elem.la
%{prefix}/lib/xine/plugins/xineplug_dmx_mpeg_elem.so
%{prefix}/lib/xine/plugins/xineplug_dmx_mpeg_pes.la
%{prefix}/lib/xine/plugins/xineplug_dmx_mpeg_pes.so
# decoder plugins
%{prefix}/lib/xine/plugins/xineplug_decode_ac3.la
%{prefix}/lib/xine/plugins/xineplug_decode_ac3.so
%{prefix}/lib/xine/plugins/xineplug_decode_mpeg2.la
%{prefix}/lib/xine/plugins/xineplug_decode_mpeg2.so
%{prefix}/lib/xine/plugins/xineplug_decode_mpg123.la
%{prefix}/lib/xine/plugins/xineplug_decode_mpg123.so
%{prefix}/lib/xine/plugins/xineplug_decode_spu.la
%{prefix}/lib/xine/plugins/xineplug_decode_spu.so
# audio driver plugins
# see other packages.
#
# video driver plugins
%{prefix}/lib/xine/plugins/xineplug_vo_out_syncfb.la
%{prefix}/lib/xine/plugins/xineplug_vo_out_syncfb.so
%{prefix}/lib/xine/plugins/xineplug_vo_out_xshm.la
%{prefix}/lib/xine/plugins/xineplug_vo_out_xshm.so
# lib and logo.
%{prefix}/lib/libxine*.la
%{prefix}/lib/libxine*.so*
%{prefix}/share/xine/skins/*

%files oss
%{prefix}/lib/xine/plugins/xineplug_ao_out_oss.la
%{prefix}/lib/xine/plugins/xineplug_ao_out_oss.so

%files alsa05
%{prefix}/lib/xine/plugins/xineplug_ao_out_alsa05.la
%{prefix}/lib/xine/plugins/xineplug_ao_out_alsa05.so

#%files alsa09
#%{prefix}/lib/xine/plugins/xineplug_ao_out_alsa.la
#%{prefix}/lib/xine/plugins/xineplug_ao_out_alsa.so

#%files arts
#%{prefix}/lib/xine/plugins/xineplug_ao_out_arts.la
#%{prefix}/lib/xine/plugins/xineplug_ao_out_arts.so

%files esd
%{prefix}/lib/xine/plugins/xineplug_ao_out_esd.la
%{prefix}/lib/xine/plugins/xineplug_ao_out_esd.so

#%files dxr3
#%{prefix}/lib/xine/plugins/xineplug_decode_dxr3.la
#%{prefix}/lib/xine/plugins/xineplug_decode_dxr3.so
#%{prefix}/lib/xine/plugins/xineplug_vo_out_dxr3.la
#%{prefix}/lib/xine/plugins/xineplug_vo_out_dxr3.so

%files xv
%{prefix}/lib/xine/plugins/xineplug_vo_out_xv.la
%{prefix}/lib/xine/plugins/xineplug_vo_out_xv.so

#%files aa
#%{prefix}/lib/xine/plugins/xineplug_vo_out_aa.la
#%{prefix}/lib/xine/plugins/xineplug_vo_out_aa.so

%files w32dll
%{prefix}/lib/xine/plugins/xineplug_decode_w32dll.la
%{prefix}/lib/xine/plugins/xineplug_decode_w32dll.so

%files docs
%{prefix}/share/doc/xine/xine-lib-API/*

%files d4d
%{prefix}/lib/xine/plugins/xineplug_inp_d4d.la
%{prefix}/lib/xine/plugins/xineplug_inp_d4d.so

%changelog
* Sun Jul 29 2001 Jos Carlos Monteiro
- included d4d plugin by Captain CSS
* Thu Jul 26 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- Made oss, aa, xv, esd, w32dll, documentation as separate packages.
* Thu Jul 26 2001 Matthias Dahl <matthew2k@web.de>
- added seperate arts package and one missing demuxer plugin to filelist
* Wed Jul 18 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- list all plugins to avoid *strange* inclusion ;-).
* Sun Jun 10 2001 Matthias Dahl <matthew2k@web.de>
- updated filelist
- re-activated execution of /sbin/ldconfig as post install script
* Thu Mar 28 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- add korean summary, patch from Louis JANG <louis@ns.mizi.com>
* Thu Jan 11 2001 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- patch from Sung-Hyun Nam <namsh@lgic.co.kr> applied.
* Fri Oct 17 2000 Daniel Caujolle-Bert <f1rmb@users.sourceforge.net>
- first spec file.
