/***************************************************************************
                          dxr2init.c  -  description
                             -------------------
    begin                : Thu Aug 9 2001
    copyright            : (C) 2001 by Raphael Zulliger
    email                : zulli@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/*
 * Minidxr2 - Linux DVD player. Mostly (C) Jack Whitham, 2001
 *
 */
#include <stdio.h>
#include <pthread.h>
#include <string.h>
#include <config.h>

#include "interface.h"
#include "player.h"
//#include "control.h"
#include "output.h"
#include "read_config.h"
//#include "message.h"


int xine_dxr2_init ( )
{
//  int c_overlay = 0;
//
//  int t;
//  int dxr2FD;
//  int driveFD = -1;
//  int mpegFD;
//  int file1;
//  int file2;
//  int uCodeFD;
//  int uCodeSize;
//  int lba;
//  dxr2_oneArg_t buf1;
//  dxr2_threeArg_t buf3;
//  dxr2_sixArg_t buf6;
//  dxr2_nineArg_t buf9;
//  dxr2_uCode_t* uCode;
//  dxr2_vgaParams_t vgaBuf;
//  int size;
//  int i;
//  int current_opt;
//  char optionsString[] = "f:d:a:r:t:";
//  char file_name[PATH_MAX];
//  char dvd_device[PATH_MAX];
//  int audio_stream = 0;
//  int ratio = 0;
//  int output_type = 0;
//  char buffer[0x20000];
//  dvd_authinfo authBuf;
//  int LBA;
//  int pid;
//  int xRes;
//  int yRes;
//  int xpos;
//  char super [0x8000];

// **************************************************************************************
// i tried to take the init-routines from minidxr2 - but somethings wrong: it compiles,
// linkes and installes, but when the demuxer is going to be loaded, it complains about
// he can't find some X-functions (something wrong with libraries?)
// **************************************************************************************
	player_info_t		* player_info;
	char				* err ;
//	int					cur_opt ;
	output_plugin_fn	output ;

	player_info = malloc ( sizeof ( player_info_t ) ) ;
	memset ( player_info , 0 , sizeof ( player_info_t ) ) ;

	/* Load in information that cannot be changed
	* (firmware file, mountpoint, etc) and defaults for audio settings */
	err = read_config ( player_info , dxr2_config_file ) ;
	if ( err != NULL )
	{
		err = read_config ( player_info , alt_config_file ) ;
		if ( err != NULL )
		{
			printf ( "%s: Error reading config file %s: %s\n" ,
					ANNOUNCE , alt_config_file , err ) ;
			return 1 ;
		}
	}

	// set output plugin to use overlay.
	output = (output_plugin_fn) dxr2_plugin_overlay ;

	player_info -> immediate_playback = IP_OFF ;
	player_info -> immediate_playback_files = 0 ;

	err = NULL ;
	player_info -> out_plugin =
			output_setup ( (void *) player_info , output , & err ) ;
	if ( err != NULL )
	{
		printf ( "%s: Error initialising output plugin: %s\n" ,
					ANNOUNCE , err ) ;
		return 1 ;
	}
	return -1;
	
	return player_info->dxr2_device;







// **************************************************************************************
// this init-routine was taken from the dxr2/test.c file. it's very simple and not very
// good - but it works
// **************************************************************************************
//
//  // source video frequency
//  // set to DXR2_SRC_VIDEO_FREQ_30 for NTSC mpegs, or DXR2_SRC_VIDEO_FREQ_25 for PAL ones
//  buf3.arg1 = DXR2_SRC_VIDEO_FREQ_25;
//  buf3.arg2 = 0x2d0;
//  buf3.arg3 = 0x1e0;
//  printf("source video format status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_SOURCE_VIDEO_FORMAT, &buf3));
//
//
//  // output aspect ratio 4:3
//  buf3.arg1 = DXR2_ASPECTRATIO_4_3;
//  printf("output aspect ratio status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_OUTPUT_ASPECT_RATIO, &buf3));
//
//
//  // source aspect ratio 4:3
//  buf3.arg1 = DXR2_ASPECTRATIO_4_3;
//  printf("source aspect ratio status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_SOURCE_ASPECT_RATIO, &buf3));
//
//
//  // use normal scaling mode (i.e. NOT letterboxed or pan/scanned
//  if (ratio == 0)
//    buf3.arg1 = DXR2_ASPECTRATIOMODE_LETTERBOX;
//  else if (ratio == 2)
//    buf3.arg1 = DXR2_ASPECTRATIOMODE_PAN_SCAN;
//  else if (ratio == 2)
//    buf3.arg1 = DXR2_ASPECTRATIOMODE_NORMAL;
//  printf("aspect ratio mode status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_ASPECT_RATIO_MODE, &buf3));
//
//
//  // macrovision off
//  buf3.arg1 = DXR2_MACROVISION_OFF;
//  printf("macrovision status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_TV_MACROVISION_MODE, &buf3));
//
//
//
//  // volume = max
//  buf3.arg1 = 19;
//  printf("volume status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_AUDIO_VOLUME, &buf3));
//
//
//  // mute is OFF
//  buf3.arg1 = DXR2_AUDIO_MUTE_OFF;
//  printf("mute off = %i\n", ioctl(dxr2FD, DXR2_IOC_AUDIO_MUTE, &buf3));
//
//
//  // 16 bit audio
//  buf3.arg1 = DXR2_AUDIO_WIDTH_16;
//  printf("audio width = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_AUDIO_DATA_WIDTH, &buf3));
//
//
//  // audio freq = 44.1 kHz
//  buf3.arg1 = DXR2_AUDIO_FREQ_96;
//  printf("audio width = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_AUDIO_SAMPLE_FREQUENCY, &buf3));
//
//
//  // not quite sure actually...
//  buf3.arg1 = DXR2_IEC958_ENCODED;
//  printf("iec958 status = %i\n", ioctl(dxr2FD, DXR2_IOC_IEC958_OUTPUT_MODE, &buf3));
//
//
//  // turn off subpictures (i.e. annoying subtitles)
//  buf3.arg1 = DXR2_SUBPICTURE_ON;
//  printf("subpicture status = %i\n", ioctl(dxr2FD, DXR2_IOC_ENABLE_SUBPICTURE, &buf3));
//
//
//  // CHANGEME
//  // select audio stream.
//  // arg1 is the type of audio stream... for MPEG1 (VCD), you'll want DXR2_STREAM_AUDIO_MPEG,
//  // and for AC3, you'll want DXR2_STREAM_AUDIO_AC3
//  // arg2 is the ID of WHICH audio stream to play.
//  buf3.arg1 = DXR2_STREAM_AUDIO_AC3;
//  //  buf3.arg1 = DXR2_STREAM_AUDIO_MPEG;
//  buf3.arg2 = audio_stream;
//  printf("select stream status = %i\n", ioctl(dxr2FD, DXR2_IOC_SELECT_STREAM, &buf3));
//
//
//  // select video stream. Just default to the first ATM
//  buf3.arg1 = DXR2_STREAM_VIDEO;
//  buf3.arg2 = 0;
//  printf("select stream status = %i\n", ioctl(dxr2FD, DXR2_IOC_SELECT_STREAM, &buf3));
//
//  // subpicture off
//  buf3.arg1 = DXR2_SUBPICTURE_OFF;
//  printf("subpicture status = %i\n", ioctl(dxr2FD, DXR2_IOC_ENABLE_SUBPICTURE, &buf3));
//
//
//  buf6.arg1 = 0;
//  buf6.arg2 = 0;
//  buf6.arg3 = 55;
//  buf6.arg4 = 300;
//  printf("set overlay cropping status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_OVERLAY_CROPPING, &buf6));
//
//
//
//  // get screen res
//  getScreenRes(&xRes, &yRes);
//
//  // OK, fork off another process to do the whitescreen thang.
//  pid = fork();
//  if (pid == 0) { // i.e. the child process
//
//    whitescreen();
//    exit(0);
//  }
//
//  // set colour key
//  buf9.arg1 = 0x40;
//  buf9.arg2 = 0xff;
//  buf9.arg3 = 0x40;
//  buf9.arg4 = 0xff;
//  buf9.arg5 = 0x40;
//  buf9.arg6 = 0xff;
//  printf("set overlay colour status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_OVERLAY_COLOUR, &buf9));
//
//
//
//  // setup window key
//  buf6.arg1 = 1000;
//  printf("set overlay ratio status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_OVERLAY_RATIO, &buf6));
//
//  buf6.arg1 = 100;
//  buf6.arg2 = 3;
//  printf("set overlay position status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_OVERLAY_POSITION, &buf6));
//
//  buf6.arg1 = xRes;
//  buf6.arg2 = yRes;
//  printf("set overlay dimension status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_OVERLAY_DIMENSION, &buf6));
//
//  // back to window keying
//  buf3.arg1 = 3;
//  printf("set overlay mode status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_OVERLAY_IN_DELAY, &buf3));
//
//
//  // turn window AND colour keying on
//  buf3.arg1 = DXR2_OVERLAY_WINDOW_COLOUR_KEY;
//  printf("set overlay mode status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_OVERLAY_MODE, &buf3));
//
//  // calculate VGA parameters
//  vgaBuf.xScreen = xRes;
//  vgaBuf.yScreen = yRes;
//  vgaBuf.hOffWinKey = 100;
//  vgaBuf.vOffWinKey = 3;
//  printf("calc = %i\n", ioctl(dxr2FD, DXR2_IOC_CALCULATE_VGA_PARAMETERS, &vgaBuf));
//
//  // set VGA parameters
//  printf("set = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_VGA_PARAMETERS, &vgaBuf));
//
//  buf6.arg1 = xRes;
//  buf6.arg2 = yRes;
//  printf("set overlay dimension status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_OVERLAY_DIMENSION, &buf6));
//
//  buf6.arg1 = 0;
//  buf6.arg2 = 0;
//  printf("set overlay position status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_OVERLAY_POSITION, &buf6));
//
//  kill( pid, 9 ) ;
//
//  // back to window keying
//  buf3.arg1 = DXR2_OVERLAY_WINDOW_KEY;
//  printf("set overlay mode status = %i\n", ioctl(dxr2FD, DXR2_IOC_SET_OVERLAY_MODE, &buf3));
//
//
//
//  // enter play mode!
//  printf("play status = %i\n", ioctl(dxr2FD, DXR2_IOC_PLAY, NULL));
//
//
//  return dxr2FD;
//
}

